Summary: An extremely capable system configuration tool.
Name: linuxconf
Version: 1.17r2
Release: 6
Copyright: GPL
Group: Applications/System
Source: ftp://ftp.solucorp.qc.ca/pub/linuxconf/devel/src/linuxconf-%{version}.src.tar.gz
Source1: linuxconf.power.gif
Patch0: linuxconf-1.17r1-rhconf.patch
Patch1: linuxconf-1.16r8-wvf.patch
# remove patch 2 as soon as we can upgrade libgd
Patch2: linuxconf-1.17r2-pnggif.patch
Patch3: linuxconf-1.17r1-bounds.patch
Patch4: linuxconf-1.17r2-nooptalpha.patch
Patch5: linuxconf-1.17r2-internaldaemons.patch
Patch6: linuxconf-1.17r5-named.patch
Url: http://www.solucorp.qc.ca/linuxconf/
BuildRoot: %{_tmppath}/%{name}-root
# Do not provide the modules
Autoprov: false
# from misc/module.h
%define MODULE_API_VERSION 15
Provides: LINUXCONFAPIREV%{MODULE_API_VERSION}
Requires: initscripts >= 3.79
Prereq: /usr/sbin/groupadd
Prereq: /etc/services
Prereq: /bin/mktemp
Prereq: sh-utils fileutils textutils grep chkconfig redhat-release
Prereq: pam
Obsoletes: usercfg fstool cabaret

%description
Linuxconf is an extremely capable system configuration tool.
Linuxconf provides four different interfaces for you to choose from:
command line, character-cell (like the installation program), an X
Window System based GUI and a web-based interface.  Linuxconf can
manage a large proportion of your system's operations, including
networking, user accounts, file systems, boot parameters, and more.

Linuxconf will simplify the process of configuring your system.
Unless you are completely happy with configuring your system manually,
you should install the linuxconf package and use linuxconf instead.

%package devel
Summary: The tools needed for developing linuxconf modules.
Group: Development/Libraries
%description devel
Linuxconf is an extremely capable system configuration tool.  It
provides a variety of interfaces through which you can configure your
Linux system and manage a large proportion of the system's operations.

This package provides the components necessary for developing
Linuxconf modules outside of the linuxconf source tree and/or
developing stand-alone utilities using the linuxconf interface
toolkit.

Install linuxconf-devel if you want to develop Linuxconf modules.  You
must also have linuxconf installed.

%prep
%setup -q
(cd conf.files/redhat/scripts
 mv S99linuxconf linuxconf
 chmod 755 linuxconf
 rm -f S00linuxconf
 rm -f grabinfo.sh)
%patch0 -p1 -b .rhconf
%patch1 -p1 -b .wvf
%patch2 -p1 -b .pnggif
%patch3 -p1 -b .bounds
%ifarch alpha
%patch4 -p0 -b .nooptalpha
%endif
%patch5 -p0 -b .internaldaemons
%patch6 -p1 -b .named
cp $RPM_SOURCE_DIR/linuxconf.power.gif images/power.gif

%build 
make

%install
export RPM_BUILD_ROOT
# do not install patched files
find conf.files -name \*.rhconf | xargs rm -f
make install_for_rpm

mkdir -p $RPM_BUILD_ROOT/var/log
for file in htmlaccess netconf ; do
        touch $RPM_BUILD_ROOT/var/log/$file.log 
        chmod 600 $RPM_BUILD_ROOT/var/log/$file.log
done

rm -f $RPM_BUILD_ROOT/usr/lib/linuxconf/install/*{caldera,conectiva,debian,suse}*
cp $RPM_BUILD_ROOT/usr/lib/linuxconf/install/conf.linuxconf-redhat-4.x  $RPM_BUILD_ROOT/etc/conf.linuxconf

make install-devel

(cd $RPM_BUILD_ROOT/usr/lib/linuxconf; find . -type f -print) | 
  grep -v '^\./help\.' | grep -v '^\.$' |
  sed 's:^\./:/usr/lib/linuxconf/:g' > libfiles
(cd $RPM_BUILD_ROOT/usr/lib/linuxconf; find . -type d -print) | 
  grep -v '^\./help\.' | grep -v '^\.$' |
  sed 's:^\./:%dir /usr/lib/linuxconf/:g' >> libfiles

%clean
if [ "$RPM_BUILD_ROOT" != "/" ] ; then
	rm -rf $RPM_BUILD_ROOT
fi

%pre
OLDINSTALL=/usr/lib/linuxconf/help.eng/notices/01-oldinstall
INITTABREPLACE=/usr/lib/linuxconf/uninstall/inittab.replace
UPGRADE="NO"

# Check for tarball installation
if [ -f /usr/lib/linuxconf/conf.daemons ] ; then
	UPGRADE="YES"
fi

if [ -f /usr/lib/linuxconf/std/conf.daemons ] ; then
	UPGRADE="YES"
fi

# Check for old 1.9r22 RPM installation
if [ -f /usr/lib/linuxconf/install/doinst.sh ] ; then
	UPGRADE="YES"
fi

if [ $UPGRADE = "YES" ] ; then
	# Script to upgrade pre-1.9r25 Linuxconf to new SysV compliant booting.
	# Dale - Hacked in a few minutes late one night :-)

	# Kill the Install directory
	if [ -f /install/doinst.sh ] ; then
		rm -Rf /install
	fi

	# Kill the old /usr/lib/linuxconf directory, the RPM will put
	# everything we need back in later.
	rm -Rf /usr/lib/linuxconf

	# Create the directories we will need for the upgrade
	install -d -g users -m 755 -o root /usr/lib/linuxconf/
	install -d -g users -m 755 -o root /usr/lib/linuxconf/help.eng/notices/
	install -d -g users -m 755 -o root /usr/lib/linuxconf/uninstall/

	# Create a note displayed by linuxconf informing that the RPM
	# install has done some cleanup
	echo "      Installation note" >$OLDINSTALL
	echo >>$OLDINSTALL
	echo "The RPM installation has detected that linuxconf was already" >>$OLDINSTALL
	echo "installed using the tar.gz kit" >>$OLDINSTALL
	echo >>$OLDINSTALL
	echo "It has taken action to fix your linuxconf installation" >>$OLDINSTALL
	echo "so it becomes more compatible with RPM based systems" >>$OLDINSTALL
	echo >>$OLDINSTALL

	# I put a default RedHat inittab in /usr/lib/linuxconf/install
	# When I unpack the distro, the original SHOULD be there, but hey,
	# You never can tell when someone is gonna need that 1k taken up
	# by the backup....
	if [ -f /etc/inittab.old ] ; then
		cp /etc/inittab /usr/lib/linuxconf/uninstall/inittab.beforeupgrade
		mv -f /etc/inittab.old /etc/inittab
	#else
		# Tell the RPM to replace this file with a stock RedHat
		# We haven't untarred anything yet, so we can't replace it
		#cp /etc/inittab /usr/lib/linuxconf/uninstall/inittab.beforeupgrade
		#touch $INITTABREPLACE
	fi

	if [ -f /etc/rc.d/rc.M ] ; then
		mv -f /etc/rc.d/rc.M /usr/lib/linuxconf/uninstall/rc.M.beforeupgrade
	fi

	if [ -f /usr/sbin/syslogd.old ] ; then
		mv -f /usr/bin/syslogd.old /usr/lib/linuxconf/uninstall/syslogd.beforelinuxconf
	fi

	if [ -f /etc/conf.linuxconf ] ; then
		mv -f /etc/conf.linuxconf /etc/conf.linuxconf-installed
	fi
fi

%post

/usr/lib/linuxconf/install/rpm-postinst.sh $*

# Add a few group ids so that the user is not prompted for them later...

# if it is an old version of groupadd, the combined -g and -r options
# will cause it to fail, so we fall back on just -r.  It will be less
# consistent across systems, but that's not too horrible.
/usr/sbin/groupadd -g 44 -r -f pppusers >/dev/null 2>&1 || \
  /usr/sbin/groupadd -r -f pppusers >/dev/null
/usr/sbin/groupadd -g 45 -r -f popusers >/dev/null 2>&1 || \
  /usr/sbin/groupadd -r -f popusers >/dev/null
/usr/sbin/groupadd -g 46 -r -f slipusers >/dev/null 2>&1 || \
  /usr/sbin/groupadd -r -f slipusers >/dev/null

%triggerin -- netkit-base inetd
# Update /etc/inetd.conf
if ! grep -q '[# \t]*linuxconf' /etc/inetd.conf ; then
        echo >> /etc/inetd.conf
        echo linuxconf stream tcp wait root /bin/linuxconf linuxconf --http >> /etc/inetd.conf
        if [ -f /var/run/inetd.pid ] ; then
                kill -HUP `cat /var/run/inetd.pid`
        fi
fi

%triggerin -- setup
# Update /etc/services
if ! grep -q '[# \t]*linuxconf' /etc/services ; then
  echo "linuxconf	98/tcp" >> /etc/services
fi

%triggerin -- named
/bin/linuxconf --setmod dnsconf
%triggerin -- dhcpd
/bin/linuxconf --setmod dhcpd
%triggerin -- sendmail
/bin/linuxconf --setmod mailconf
%triggerin -- apache
/bin/linuxconf --setmod apache
%triggerin -- samba
/bin/linuxconf --setmod samba
%triggerin -- wu-ftpd
/bin/linuxconf --setmod wuftpd
%triggerun -- named
# we do not use --unsetmod because we want to leave a module that is
# explicitly turned off that way even if the triggered package is
# afterwards reinstalled...
[ $2 = 0 ] || exit 0
TMPFILE=`mktemp /tmp/lct.XXXXXX` || exit 1
sed '/^module.list 1 dnsconf$/d' < /etc/conf.linuxconf > $TMPFILE || exit 2
mv $TMPFILE /etc/conf.linuxconf || { rm -f $TMPFILE ; exit 3 ; }
%triggerun -- dhcpd
[ $2 = 0 ] || exit 0
TMPFILE=`mktemp /tmp/lct.XXXXXX` || exit 1
sed '/^module.list 1 dhcpd$/d' < /etc/conf.linuxconf > $TMPFILE || exit 2
mv $TMPFILE /etc/conf.linuxconf || { rm -f $TMPFILE ; exit 3 ; }
%triggerun -- sendmail
[ $2 = 0 ] || exit 0
TMPFILE=`mktemp /tmp/lct.XXXXXX` || exit 1
sed '/^module.list 1 mailconf$/d' < /etc/conf.linuxconf > $TMPFILE || exit 2
mv $TMPFILE /etc/conf.linuxconf || { rm -f $TMPFILE ; exit 3 ; }
%triggerun -- apache
[ $2 = 0 ] || exit 0
TMPFILE=`mktemp /tmp/lct.XXXXXX` || exit 1
sed '/^module.list 1 apache$/d' < /etc/conf.linuxconf > $TMPFILE || exit 2
mv $TMPFILE /etc/conf.linuxconf || { rm -f $TMPFILE ; exit 3 ; }
%triggerun -- samba
[ $2 = 0 ] || exit 0
TMPFILE=`mktemp /tmp/lct.XXXXXX` || exit 1
sed '/^module.list 1 samba$/d' < /etc/conf.linuxconf > $TMPFILE || exit 2
mv $TMPFILE /etc/conf.linuxconf || { rm -f $TMPFILE ; exit 3 ; }
%triggerun -- wu-ftpd
[ $2 = 0 ] || exit 0
TMPFILE=`mktemp /tmp/lct.XXXXXX` || exit 1
sed '/^module.list 1 wuftpd$/d' < /etc/conf.linuxconf > $TMPFILE || exit 2
mv $TMPFILE /etc/conf.linuxconf || { rm -f $TMPFILE ; exit 3 ; }

%preun
# The script is handed a 0 if this is a uninstall
# and a 1 if it is an upgrade...
/usr/lib/linuxconf/install/rpm-preuninst.sh $1

%postun
if [ "$1" = 0 ] ; then

	# remove linuxconf from /etc/inetd.conf if it is there
	if [ -f /etc/inetd.conf ] &&
   	grep linuxconf /etc/inetd.conf >/dev/null 2>&1 ; then
		if grep -v linuxconf /etc/inetd.conf > /tmp/inetd.$$ ; then
			mv /tmp/inetd.$$ /etc/inetd.conf
		fi
	fi

	rm -f /var/run/treemenu.cache

fi

%files -f libfiles
%defattr(-,root,root)
%config(noreplace) %verify(not md5 size mtime) /etc/conf.linuxconf
%config /etc/pam.d/linuxconf
%config /etc/pam.d/linuxconf-pair
%config /etc/logrotate.d/linuxconf
%dir /usr/lib/linuxconf/
/usr/lib/linuxconf/help.eng
%lang(zh) /usr/lib/linuxconf/help.bg5
%lang(fr_CA) /usr/lib/linuxconf/help.cn
%lang(cs) /usr/lib/linuxconf/help.cs
%lang(de) /usr/lib/linuxconf/help.de
%lang(es) /usr/lib/linuxconf/help.es
%lang(fi) /usr/lib/linuxconf/help.fi
%lang(fr) /usr/lib/linuxconf/help.fr
%lang(it) /usr/lib/linuxconf/help.it
%lang(ko) /usr/lib/linuxconf/help.ko
%lang(no) /usr/lib/linuxconf/help.no
%lang(pt) /usr/lib/linuxconf/help.pt
%lang(se) /usr/lib/linuxconf/help.se
%lang(sk) /usr/lib/linuxconf/help.sk
/bin/linuxconf
/bin/netconf
/bin/fsconf
/sbin/askrunlevel
/sbin/dnsconf
/sbin/fixperm
/sbin/mailconf
/bin/userconf
%config /bin/remadmin

%ghost /var/log/htmlaccess.log
%ghost /var/log/netconf.log

%doc rpmfiles/doc/COPYING
%doc rpmfiles/doc/HELPING
%doc rpmfiles/doc/RPM-CHANGES
%doc rpmfiles/doc/RPM-INSTALL
%doc rpmfiles/doc/RPM-README
%doc rpmfiles/doc/UPGRADE

%files devel
/usr/include/linuxconf
/usr/lib/liblinuxconf.a
/usr/lib/linuxconf-devel

%changelog
* Tue Mar 07 2000 Nalin Dahyabhai <nalin@redhat.com>
- change ownership of directories created under /var/named to named.named
- add inetd to trigger that adds linuxconf to inetd.conf
- fix newly-broken regex checks in triggers

* Wed Mar 01 2000 Nalin Dahyabhai <nalin@redhat.com>
- change groups created in post-install to have GIDs under 100

* Fri Jan 21 2000 Nalin Dahyabhai <nalin@redhat.com>
- back out dialogs patch, which breaks linuxconf if not started in a terminal
- back out pam_unix patch, going another route
- make sure init script has execute bit set

* Thu Jan 20 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix paths in linuxconf.internaldaemons

* Mon Jan 17 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 1.17r2
- note that help.cfr has become help.cn
- integrate patch to stop dialog-related segfaults from edward.huff@acm.org
- make default distribution "redhat" instead of "std"

* Wed Jan 12 2000 Nalin Dahyabhai <nalin@redhat.com>
- updated to linuxconf 1.17r1
- add patch to fix easy-to-spot potential buffer overflows

* Mon Jan 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- change to only append entry to /etc/inetd.conf if it isn't mentioned at all

* Tue Jan  4 2000 Nalin Dahyabhai <nalin@redhat.com>
- change to only append entry to /etc/services if it isn't mentioned at all

* Thu Dec 16 1999 Michael K. Johnson <johnsonm@redhat.com>
- pulled in chat patch

* Tue Dec 14 1999 Michael K. Johnson <johnsonm@redhat.com>
- pulled in Jacques' errata patch

* Thu Dec 02 1999 Michael K. Johnson <johnsonm@redhat.com>
- updated to linuxconf 1.16r10 to fix a few more bugs
- added rbl patches that will be in 1.16r11 when it is released
- removed xconf

* Wed Dec 01 1999 Michael K. Johnson <johnsonm@redhat.com>
- updated to linuxconf 1.16r9 to fix a few more bugs

* Wed Nov 24 1999 Michael K. Johnson <johnsonm@redhat.com>
- updated to linuxconf 1.16r8 to see which bugs are fixed.
- removed lpdconf as it is insufficient on Red Hat Linux systems

* Sat Sep 25 1999 Michael K. Johnson <johnsonm@redhat.com>
- reverted redhatppp module to an older, presumed working version
  because wvdial support in the new one breaks otherwise working
  setups.

* Tue Sep 21 1999 Michael K. Johnson <johnsonm@redhat.com>
- updated to 1.16r3.2
- install main help files only for languages in use on the system

* Mon Sep 20 1999 Michael K. Johnson <johnsonm@redhat.com>
- updated to 1.16r3

* Sat Aug 28 1999 Michael K. Johnson <johnsonm@redhat.com>
- fixed quota.conf permissions problem

* Tue Jul 27 1999 Michael K. Johnson <johnsonm@redhat.com>
- Update to 1.16r1.3 to deal with a few more bug reports

* Fri Jul 16 1999 Michael K. Johnson <johnsonm@redhat.com>
- Update to 1.16r1.1 to deal with a number of bug reports

* Wed Apr 14 1999 Michael K. Johnson <johnsonm@redhat.com>
- setup trigger for /etc/services instead of postinstall
- moved /etc/conf.linuxconf to a noreplace config file

* Fri Apr 09 1999 Michael K. Johnson <johnsonm@redhat.com>
- update to 1.14r4
- fix kmap/map confusion
- fix dnsrecs combos not to be empty
- be more conservative about finding phone numbers

* Wed Apr 07 1999 Michael K. Johnson <johnsonm@redhat.com>
- update to 1.14r3
- added more triggers
- sendmail V8 .cf

* Mon Apr 05 1999 Michael K. Johnson <johnsonm@redhat.com>
- prerequire redhat-release
- remove ghost reference to boot.log in logrotate file.

* Wed Mar 31 1999 Michael K. Johnson <johnsonm@redhat.com>
- dhcpd config should trust dhcpd or dhcpd script to put in correct routes

* Tue Mar 30 1999 Michael K. Johnson <johnsonm@redhat.com>
- updated to 1.14r2
- added defattr

* Mon Mar 29 1999 Michael K. Johnson <johnsonm@redhat.com>
- fixed ppp device names
- added a bunch of modules by default

* Thu Mar 25 1999 Michael K. Johnson <johnsonm@redhat.com>
- removed /var/log/boot.log (not used on Red Hat Linux)
- add redhatppp module by default
- fix /var/spol/mqueue permissions

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Thu Mar 18 1999 Michael K. Johnson <johnsonm@redhat.com>
- do not install old versions of patch files
- perm -> umask to fix bug #418

* Mon Mar 15 1999 Michael K. Johnson <johnsonm@redhat.com>
- french messages

* Thu Mar 11 1999 Michael K. Johnson <johnsonm@redhat.com>
- moved to 1.14

* Wed Mar 10 1999 Michael K. Johnson <johnsonm@redhat.com>
- Moved to pristine source from internal CVS archive
